/*
 * MATLAB Compiler: 4.14 (R2010b)
 * Date: Mon Feb 13 10:18:46 2012
 * Arguments: "-B" "macro_default" "-B" "csharedlib:libfoo" "-W" "lib:libfoo"
 * "-T" "link:lib" "foo.m" 
 */

#include <stdio.h>
#define EXPORTING_libfoo 1
#include "libfoo.h"

static HMCRINSTANCE _mcr_inst = NULL;


#ifdef __cplusplus
extern "C" {
#endif

static int mclDefaultPrintHandler(const char *s)
{
  return mclWrite(1 /* stdout */, s, sizeof(char)*strlen(s));
}

#ifdef __cplusplus
} /* End extern "C" block */
#endif

#ifdef __cplusplus
extern "C" {
#endif

static int mclDefaultErrorHandler(const char *s)
{
  int written = 0;
  size_t len = 0;
  len = strlen(s);
  written = mclWrite(2 /* stderr */, s, sizeof(char)*len);
  if (len > 0 && s[ len-1 ] != '\n')
    written += mclWrite(2 /* stderr */, "\n", sizeof(char));
  return written;
}

#ifdef __cplusplus
} /* End extern "C" block */
#endif

/* This symbol is defined in shared libraries. Define it here
 * (to nothing) in case this isn't a shared library. 
 */
#ifndef LIB_libfoo_C_API
#define LIB_libfoo_C_API /* No special import/export declaration */
#endif

LIB_libfoo_C_API 
bool MW_CALL_CONV libfooInitializeWithHandlers(
    mclOutputHandlerFcn error_handler,
    mclOutputHandlerFcn print_handler)
{
    int bResult = 0;
  if (_mcr_inst != NULL)
    return true;
  if (!mclmcrInitialize())
    return false;
    {
        mclCtfStream ctfStream = 
            mclGetEmbeddedCtfStream((void *)(libfooInitializeWithHandlers), 
                                    76098);
        if (ctfStream) {
            bResult = mclInitializeComponentInstanceEmbedded(   &_mcr_inst,
                                                                error_handler, 
                                                                print_handler,
                                                                ctfStream, 
                                                                76098);
            mclDestroyStream(ctfStream);
        } else {
            bResult = 0;
        }
    }  
    if (!bResult)
    return false;
  return true;
}

LIB_libfoo_C_API 
bool MW_CALL_CONV libfooInitialize(void)
{
  return libfooInitializeWithHandlers(mclDefaultErrorHandler, mclDefaultPrintHandler);
}

LIB_libfoo_C_API 
void MW_CALL_CONV libfooTerminate(void)
{
  if (_mcr_inst != NULL)
    mclTerminateInstance(&_mcr_inst);
}

LIB_libfoo_C_API 
long MW_CALL_CONV libfooGetMcrID() 
{
  return mclGetID(_mcr_inst);
}

LIB_libfoo_C_API 
void MW_CALL_CONV libfooPrintStackTrace(void) 
{
  char** stackTrace;
  int stackDepth = mclGetStackTrace(&stackTrace);
  int i;
  for(i=0; i<stackDepth; i++)
  {
    mclWrite(2 /* stderr */, stackTrace[i], sizeof(char)*strlen(stackTrace[i]));
    mclWrite(2 /* stderr */, "\n", sizeof(char)*strlen("\n"));
  }
  mclFreeStackTrace(&stackTrace, stackDepth);
}


LIB_libfoo_C_API 
bool MW_CALL_CONV mlxFoo(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "foo", nlhs, plhs, nrhs, prhs);
}

LIB_libfoo_C_API 
bool MW_CALL_CONV mlfFoo(int nargout, mxArray** y, mxArray* x)
{
  return mclMlfFeval(_mcr_inst, "foo", nargout, 1, 1, y, x);
}
