/*
 * MATLAB Compiler: 4.14 (R2010b)
 * Date: Mon Feb 13 10:18:46 2012
 * Arguments: "-B" "macro_default" "-B" "csharedlib:libfoo" "-W" "lib:libfoo"
 * "-T" "link:lib" "foo.m" 
 */

#ifndef __libfoo_h
#define __libfoo_h 1

#if defined(__cplusplus) && !defined(mclmcrrt_h) && defined(__linux__)
#  pragma implementation "mclmcrrt.h"
#endif
#include "mclmcrrt.h"
#ifdef __cplusplus
extern "C" {
#endif

#if defined(__SUNPRO_CC)
/* Solaris shared libraries use __global, rather than mapfiles
 * to define the API exported from a shared library. __global is
 * only necessary when building the library -- files including
 * this header file to use the library do not need the __global
 * declaration; hence the EXPORTING_<library> logic.
 */

#ifdef EXPORTING_libfoo
#define PUBLIC_libfoo_C_API __global
#else
#define PUBLIC_libfoo_C_API /* No import statement needed. */
#endif

#define LIB_libfoo_C_API PUBLIC_libfoo_C_API

#elif defined(_HPUX_SOURCE)

#ifdef EXPORTING_libfoo
#define PUBLIC_libfoo_C_API __declspec(dllexport)
#else
#define PUBLIC_libfoo_C_API __declspec(dllimport)
#endif

#define LIB_libfoo_C_API PUBLIC_libfoo_C_API


#else

#define LIB_libfoo_C_API

#endif

/* This symbol is defined in shared libraries. Define it here
 * (to nothing) in case this isn't a shared library. 
 */
#ifndef LIB_libfoo_C_API 
#define LIB_libfoo_C_API /* No special import/export declaration */
#endif

extern LIB_libfoo_C_API 
bool MW_CALL_CONV libfooInitializeWithHandlers(
       mclOutputHandlerFcn error_handler, 
       mclOutputHandlerFcn print_handler);

extern LIB_libfoo_C_API 
bool MW_CALL_CONV libfooInitialize(void);

extern LIB_libfoo_C_API 
void MW_CALL_CONV libfooTerminate(void);



extern LIB_libfoo_C_API 
void MW_CALL_CONV libfooPrintStackTrace(void);

extern LIB_libfoo_C_API 
bool MW_CALL_CONV mlxFoo(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[]);

extern LIB_libfoo_C_API 
long MW_CALL_CONV libfooGetMcrID();



extern LIB_libfoo_C_API bool MW_CALL_CONV mlfFoo(int nargout, mxArray** y, mxArray* x);

#ifdef __cplusplus
}
#endif
#endif
